{ 2004-03-13 programmeerimisvistluse algajate 3. lesande lahendus         }
{ lesanne: ELEKTRITOIDE                                                    }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'EL.SIS';                                      { sisendfaili nimi }
   valf = 'EL.VAL';                                     { vljundfaili nimi }
   maxn = 1000;                                    { maksimaalne radade arv }

type
   loik = record
      x1, y1, x2, y2 : integer;
      k : integer;                               { sidususkomponendi number }
   end;

var
   n : integer;
   a : array [1..maxn] of loik;
   f : text;
   i, k : integer;

{ kontrollib, kas a1..a2 ja b1..b2 kattuvad }
function kattuvad(a1, a2, b1, b2 : integer) : boolean;
var mina, maxa, minb, maxb : integer;
begin
   if a1 < a2 then mina := a1 else mina := a2;
   if a1 > a2 then maxa := a1 else maxa := a2;
   if b1 < b2 then minb := b1 else minb := b2;
   if b1 > b2 then maxb := b1 else maxb := b2;
   if mina > maxb then exit(false);
   if minb > maxa then exit(false);
   exit(true);
end;

{ kontrollib, kas punkt (x,y) jb ligust l "vasakule" vi "paremale" }
function suund(var l : loik; x, y : integer) : integer;
var dx1, dy1, dx2, dy2, z : longint;
begin
   dx1 := l.x2 - l.x1; dy1 := l.y2 - l.y1;
   dx2 := x - l.x1; dy2 := y - l.y1;
   z := dx1 * dy2 - dy1 * dx2;
   if z < 0 then exit(-1);
   if z > 0 then exit(1);
   exit(0);
end;

{ kontrollib, kas likudel l1 ja l2 on hiseid punkte }
function loikuvad(var l1, l2 : loik) : boolean;
var z11, z12, z21, z22 : integer;
begin
   if not kattuvad(l1.x1, l1.x2, l2.x1, l2.x2) then exit(false);
   if not kattuvad(l1.y1, l1.y2, l2.y1, l2.y2) then exit(false);
   z11 := suund(l1, l2.x1, l2.y1);
   z12 := suund(l1, l2.x2, l2.y2);
   z21 := suund(l2, l1.x1, l1.y1);
   z22 := suund(l2, l1.x2, l1.y2);
   exit((z11 * z12 <= 0) and (z21 * z22 <= 0));
end;

{ mrgib rada i sisaldava sidususkomponendi }
procedure margi(i, k : integer);
var j : integer;
begin
   a[i].k := k;
   for j := 1 to n do
      if a[j].k < 0 then
         if loikuvad(a[i], a[j]) then
            margi(j, 0);
end;

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, a[i].x1, a[i].y1, a[i].x2,a[i].y2);
   close(f);

   { lahendame }
   for i := 1 to n do
      a[i].k := -1;
   k := 0;
   for i := 1 to n do
      if a[i].k < 0 then begin
         k := k + 1;
         margi(i, k);
      end;

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   writeln(f, k);
   for i := 1 to n do
      if a[i].k > 0 then
         writeln(f, a[i].x1, ' ', a[i].y1);
   close(f);
end.
