// 2004-03-13 programmeerimisvistluse edasijudnute 2. lesande lahendus
// lesanne: HULKNURK
// Autor: Heno Ivanov
// Testitud: GCC 3.2 / Win32, GCC / Linux

#define PI 3.1415926535897932384626433832795028841968
#define eps 0.00001

#define INFILE "HN.SIS"
#define OUTFILE "HN.VAL"

#include <stdio.h>
#include <math.h>
#include <assert.h>

int main()
{
	FILE *fi;
	FILE *fo;

	int n;
	double k1,k2;
	double t1,t2;

	double c;
	double b;
	double a;
	double u;
	double s;
	double p1,p2;

	double basefi;
	int i;

	fi = fopen(INFILE,"r");
	fo = fopen(OUTFILE,"w");

	fscanf(fi,"%d\n",&n);
	fscanf(fi,"%lf %lf\n",&k1,&k2);
	fscanf(fi,"%lf %lf\n",&t1,&t2);

	c = sqrt((k1-t1)*(k1-t1) + (k2-t2)*(k2-t2));
	b = c * cos(PI/n);
	a = c * sin(PI/n);

	u = n * 2 * a;
	s = b * a * n;

	fprintf(fo,"%.3lf\n",u);
	fprintf(fo,"%.3lf\n",s);

	basefi = atan((k1-t1)/(k2-t2));

	if ((t2-k2) <= 0)
		basefi += PI ;

	// olukord, kus atan() on mramata tekib,
	// kui punktid langevad kokku,
	// siis vime valida suvalise nurga
	if (isnan(basefi))
		basefi = 0;
#ifdef DEBUG
	printf("basefi = %lf\n",basefi);
#endif

	for (i=0;i<n;i++) {
		p1 = k1+c*sin(basefi + i * ( 2 * PI / n));
		p2 = k2+c*cos(basefi + i * ( 2 * PI / n));
		assert((i != 0) || ((fabs(p1-t1) < eps) && (fabs(p2-t2) < eps)));
		fprintf(fo,"%.3lf %.3lf\n",p1,p2);
	}

	fclose(fo);
	fclose(fi);
	return 0;
}
