// 2004-03-13 programmeerimisvistluse edasijudnute 2. lesande tester
// lesanne: HULKNURK
// Autor: Heno Ivanov

#define PI 3.1415926535897932384626433832795028841968
#define eps 0.00001

#define teps 0.0006

#include <stdio.h>
#include <math.h>
#include <assert.h>
#include <strings.h>

int u_kontroll(FILE *fo);

int main(int argc, const char *argv[])
{
	FILE *fi;
	FILE *fo;

	int n;
	double k1,k2;
	double t1,t2;

	double c;
	double b;
	double a;
	double u;
	double s;
	double p1,p2;

	double test1,test2;

	double basefi;
	int i;
	int score = 0 ;
	int pfail = 0 ;
	

	fi = fopen(argv[1],"r");
	if ((fo = fopen(argv[2],"r")) == NULL) {
		printf("Faili pole!\n");
		goto tend;
	}

	fscanf(fi,"%d\n",&n);
	fscanf(fi,"%lf %lf\n",&k1,&k2);
	fscanf(fi,"%lf %lf\n",&t1,&t2);

	c = sqrt((k1-t1)*(k1-t1) + (k2-t2)*(k2-t2));
	b = c * cos(PI/n);
	a = c * sin(PI/n);

	u = n * 2 * a;
	s = b * a * n;

	if (fscanf(fo,"%lf\n",&test1)==1) 
		if (fabs(test1 - u ) < teps)
			printf("Ymbermt:  - OK\n");
		else 
			printf("Ymbermt: %.3lf (ige vastus %.8lf)\n",test1,u);
	else {
		printf("Formaadi viga!\n");
		test1=-99999;
	}

	if (fscanf(fo,"%lf\n",&test2) == 1) {
		if (fabs(test2 - s ) < teps) 
			printf("Pindala:    - OK\n");
		else 
			printf("Pindala:  %.3lf (ige vastus %.8lf)\n",test2,s);
	} else {
		printf("Formaadi viga!\n");
		test2=-99999;
	}

	if ((fabs(test1 - u ) < teps) && (fabs(test2 - s ) < teps)) {
		score += 1;
	}

	basefi = atan((k1-t1)/(k2-t2));

	if ((t2-k2) <= 0)
		basefi += PI ;

	// olukord, kus atan() on mramata tekib,
	// kui punktid langevad kokku,
	// siis vime valida suvalise nurga
	if (isnan(basefi)) 
		basefi = 0;
#ifdef DEBUG
	printf("basefi = %lf\n",basefi);
#endif

	for (i=0;i<n;i++) {
		p1 = k1+c*sin(basefi + i * (2 * PI / n));
		p2 = k2+c*cos(basefi + i * (2 * PI / n));
		assert((i != 0) || ((fabs(p1-t1) < eps) && (fabs(p2-t2) < eps)));

		if (fscanf(fo,"%lf %lf\n",&test1,&test2) != 2) {
			printf("Failiformaadi viga!\n");
			pfail=1;
			break;
		}

		if ((fabs(test1 - p1 ) < teps) && (fabs(test2 - p2 ) < teps)) {
			continue;
		} else {
			printf("Vale tipp nr. %2d (%12.8lf,%12.8lf)\n",i+1,test1,test2);
			printf("           ige: (%12.8lf,%12.8lf)\n",p1,p2);
			pfail = 1;
			break;
		}
	}

	if (!pfail) {
		score += 2;
		printf("Tipud:      - OK\n");
	}

	u_kontroll(fo);
tend:
	printf("Punktid: %d\n",score);

	if (fo != NULL)
		fclose(fo);
	if (fi != NULL)
		fclose(fi);

	return 0;
}

int u_kontroll(FILE *fo) {
	char sbuf[1000];
	assert(fo!=NULL);
	fseek(fo,0L,SEEK_SET);

	while (fscanf(fo,"%s",sbuf) == 1) {
		if ((strrchr(sbuf,'.')!= NULL) && strlen(strrchr(sbuf,'.')) > 4) {
			printf("Hoiatus: %s ei ole mardatud 3 kohani!\n",sbuf);
			break;
		}
	}
	return 0;
}
