{ 2004-03-13 programmeerimisvistluse algajate 2. lesande lahendus         }
{ lesanne: MUSTKUNSTNIK                                                    }
{ Autor: Avo Muromgi                                                       }
{ Testitud: FPC 1.0.10 / Win32                                              }

{
 Antud n ja k. Leida n! / (k! * (n - k)!).
 Kombinatsioonide arv leitakse rekursiivselt Pascali kolmnurgast:
 C(n, k) = C(n - 1, k - 1) + C(n - 1, k),
 kus C(n, k) on Pascali kolmnurga rea n+1 element jrk nr-ga k.
 Tema leidmiseks liidame kokku temast vasakul leval ja paremal leval
 oleva elemendi.

 PS. Pascali kolmnurk neb vlja nrgmine
         1
        1 1
       1 2 1
      1 3 3 1
     1 4 6 4 1
    ...........

 Elemendi vrtus leitakse temast paremal lal ja vasakul lal asuva
 elemendi summeerimisel. Iga rea esimene ja ka viimane element on 1.

 Seda kolmnurka saab vaadelda ka kujul:
             C(0,0)
         C(1,0)  C(1,1)
     C(2,0)  C(2,1)  C(2,2)
 C(3,0)  C(3,1)  C(3,2)  C(3,3)
................................
}

const
  sn = 'MK.SIS';
  vn = 'MK.VAL';
  maxn = 200;//maksimaalne n vrtus
  maxl = 61;//maksimaalne vimalik vastuse pikkus
  base = 10;//kasutatav arvussteem

type
  TBigNum = record
    int : array [1..maxl] of integer;//arv ise
    l : integer;//numbrite arv arvus
  end;

procedure readInput(var n, k : integer);
  var
    inf : text;
  begin
    assign(inf, sn);reset(inf);
    readln(inf, n, k);
    close(inf);
  end;

procedure writeOutput(C : TBigNum);
  var
    i : integer;
    outf : text;
  begin
    assign(outf, vn);rewrite(outf);
    for i := C.l downto 1 do
      write(outf, C.int[i]);
    writeln(outf);
    close(outf);
  end;

function sum(a, b : TBigNum) : TBigNum;
  var
    i : integer;
    maxAB : integer;//suurema numbrite arvuga arvu pikkus
    x : integer;
  begin
    if a.l >= b.l then maxAB := a.l else maxAB := b.l;
    x := 0;
    for i := 1 to maxAB do begin
      if i <= a.l then inc(x, a.int[i]);
      if i <= b.l then inc(x, b.int[i]);
      sum.int[i] := x mod base;
      x := x div base;
    end;
    if x > 0 then begin
      sum.int[maxAB + 1] := x;
      sum.l := maxAB + 1;
    end
    else sum.l := maxAB;
  end;

var
  pascal : array [2..(maxn + 2) * (maxn + 1) div 2] of TBigNum;//pascali kolmnurk
  //kui pascal.l <= 0, siis pole talle veel vrtust leitud

//algvrtustame pascali kolmnurga iga rea esimese ja viimase elemendi
procedure init(n : integer);
  var
    i : longint;
  begin
    for i := 4 to n * (n + 1) div 2 do
      pascal[i].l := 0;
    //salvestame pascali kolmnurga iga rea esimese ja viimase elemendi
    for i := 1 to n do begin
      pascal[(i + 1) * i div 2 + 1].l := 1;
      pascal[(i + 1) * i div 2 + 1].int[1] := 1;
      pascal[(i + 1) * i div 2 + 1 + i].l := 1;
      pascal[(i + 1) * i div 2 + 1 + i].int[1] := 1;
    end;
  end;

function combinations(n, k : integer) : TBigNum;
  var
    rowIndex : longint;//rea (n+1) esimese elemendi index masiivis
  begin
    rowIndex := n * (n + 1) div 2 + 1;    
    if pascal[rowIndex + k].l <= 0 then
      pascal[rowIndex + k] :=
        sum(combinations(n - 1, k - 1), combinations(n - 1, k));
    combinations := pascal[rowIndex + k];
  end;

var
  k, n : integer;
begin
  readInput(n, k);
  init(n);
  writeOutput(combinations(n, k));
end.
